#导入库
import tensorflow as tf
import matplotlib.pyplot as plt

fashion_mnist = tf.keras.datasets.fashion_mnist
(X_train, y_train), (X_test, y_test) = fashion_mnist.load_data()                     #【_1_】

#利用reshape函数转换数字图像
X_train_reshape = X_train.reshape(X_train.shape[0], 28*28) 
X_test_reshape = X_test.reshape(X_test.shape[0], 28*28)    

#归一化数字图像
X_train_norm, X_test_norm = X_train_reshape / 255.0, X_test_reshape / 255.0  

#显示训练集第11个图像
plt.figure() 
plt.imshow(X_train[10], cmap='gray')
plt.show()

# 构建Sequential模型
model = tf.keras.models.Sequential() 
model.add(tf.keras.layers.Dense(400,input_dim=28*28,activation='relu',name='Hidden1')) #【_2_】
model.add(tf.keras.layers.Dense(500, activation='relu', name='Hidden2'))
model.add(tf.keras.layers.Dense(300, activation='relu', name='Hidden3'))
model.add(tf.keras.layers.Dense(10,activation='softmax',name='Output')) 

#模型编译
model.compile(optimizer='sgd',
              loss='sparse_categorical_crossentropy',
              metrics=['accuracy'])

model.fit(X_train_norm, y_train, epochs=15, verbose=2, validation_split=0.2)         #【_3_】

model.evaluate(X_test_norm, y_test)                                                  #【_4_】

model.save('my_model.h5')                                                            #【_5_】

